#ifndef CONJUNTO_H
#define CONJUNTO_H

#include <stdio.h>
#include "poligono.h"

// Representa um conjunto de pontos.
class Conjunto {
  private:
  static const double SMALL;

  Poligono *fecho;     // Fecho convexo calculado.
  Ponto *pontos;       // Vetor de pontos do conjunto.
  int n;               // Numero de pontos.
  int primeiro;        // Booleana usada para calcular o tamanho do espaco
                       // usada pelos pontos.
  int *index, *temp;   // Vetores usados no mergersort e no graham.
  double ultimaArea;   // Ultimo resultado da chamada de Area2.
  double esquerda, direita, emcima, embaixo; // Retangulo ocupado pelos pontos;
  int global_cont;     // Contador usada para o numero de Areas.
  int sleep_time;      // Tempo de espera entre um desenho e outro

  double Area2(Ponto &p1, Ponto &p2, Ponto &p3); // Calcula a area.
  double Distancia_rt(Ponto &p1, Ponto &p2);     // Distancia ao quadrado.
  bool Left(Ponto &p1, Ponto &p2, Ponto &p3);    // Primitiva Left.
  void mergeSort(int *index, int inic, int fim); // Ordenacao.

  public:
  Conjunto(int num);
  ~Conjunto();

  void imprimePontos();   // Desenha os pontos na tela.
  void inserePonto(int pos, double x, double y); // Insere um ponto no conjunto.
  Poligono *Embrulho();   // Calcula o fecho pelo Embrulho Para Presente.
  Poligono *Graham();     // Calcula o fecho pelo Algoritmo de Graham.

  inline void setSleepTime(int st) { sleep_time = st; } // Seta o sleeo_time.
  inline double Esquerda() { return esquerda; } // Funcoes usadas para 
  inline double Direita() { return direita; }   //  retornar as dimensoes do
  inline double Emcima() { return emcima; }     //  retangulo que os pontos
  inline double Embaixo() { return embaixo; }   //  do conjunto ocupam.
};

#endif
