#include <stdio.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include "poligono.h"

// Destrutor.
Poligono::~Poligono() {
  lista = lista->prox;
  cont = 0;
  while (lista != NULL) {
    delete lista->prev;
    lista = lista->prox;
  }
  delete fim;
}

// Remove um ponto da lista.
void Poligono::removeVertex() {
  if (lista == 0)
    return;

  Vertex *old = fim;
  fim->prev->prox = 0;
  fim = fim->prev;
  n--;
  delete old;
}

// Insere um ponto.
void Poligono::insereVertex(Ponto &p) {
  if (lista == 0) {
    lista = new Vertex();
    lista->ponto = p;
    fim = lista;
    n = 1;
    return;
  }

  Vertex *novo = new Vertex();
  novo->prox = 0;
  novo->prev = fim;
  fim->prox = novo;
  novo->ponto = p;
  fim = novo;
  n++;
}

// Imprime os pontos que formam o poligono.
void Poligono::Imprime(FILE *out) {
  Vertex *atual = lista;
  int i = 0;

  fprintf(out, "Numero de calculo de area: %d\n", cont);
  while (atual != 0) {
    fprintf(out, "Vertice %d - (%8.4f, %8.4f)\n", i++,
            atual->ponto.x, atual->ponto.y);
    atual = atual->prox;
  }
}

// Desenha o poligono inteiro na tela.
void Poligono::imprimePoligono() {
  Vertex *atual = lista;
  
  glColor3f(0.0, 0.3, 1.0);
  glBegin(GL_LINE_LOOP);
  while(atual != NULL) {
    glVertex2f(atual->ponto.x, atual->ponto.y);
    atual = atual->prox;
  }
  glEnd();
}

// Desenha as arestas existentes ate o momento.
// Nao desenha uma aresta do primeiro ao ultimo ponto.
void Poligono::imprimeParcial() {
  Vertex *atual = lista;
  
  glColor3f(0.0, 0.3, 1.0);
  glBegin(GL_LINE_STRIP);
  while(atual != NULL) {
    glVertex2f(atual->ponto.x, atual->ponto.y);
    atual = atual->prox;
  }
  glEnd();
}

