#ifndef POLIGONO_H
#define POLIGONO_H

// Representacao de um ponto.
struct Ponto {
  double x, y;
  Ponto() {}

  Ponto &operator=(Ponto &p) { x = p.x; y = p.y; return *this; }
};

// Representacao de um poligono.
class Poligono {
  private:

  // Celula de uma lista duplamente ligada de pontos.
  struct Vertex {
    Ponto ponto;
    struct Vertex *prox;
    struct Vertex *prev;
    Vertex():prox(0), prev(0) {}
  };

  int n, cont;   // Numero de vertices e uma variavel extra.
  Vertex *lista; // Ponteiros para a lista ligada.
  Vertex *fim;

  public:
  Poligono(): n(0), lista(0), fim(0) {}
  ~Poligono();

  void insereVertex(Ponto &p);  // Insere um vertice.
  void removeVertex();          // Remove um vertice.
  void Imprime(FILE *out);      // Imprime o poligono em out.
  void imprimePoligono();       // Desenha o poligono inteiro.
  void imprimeParcial();        // Desenha uma parte do poligono
  inline int numVertex() { return n; }      // Retorna n.
  inline void setaCont(int c) { cont = c; } // Altera cont.
  inline int pegaCont() { return cont; }    // Retorna cont.
};

#endif
